/*
   Page 3 of
   http://pages.cs.wisc.edu/~remzi/OSTEP/threads-cv.pdf

   Figure 30.3: Parent Waiting For Child: Use A Condition Variable
*/
#include <stdio.h>
#include "mythreads.h"

int done = 0;
pthread_mutex_t m = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  c = PTHREAD_COND_INITIALIZER;

void *child(void *arg)
{
   printf("child\n");
   Pthread_mutex_lock(&m);   // XXX indicate that we are done.
   done = 1;                 // XXX indicate that we are done.
   pthread_cond_signal(&c);  // XXX indicate that we are done.
   Pthread_mutex_unlock(&m); // XXX indicate that we are done.
   return NULL;
}

int main( )
{
   printf("parent: begin\n");
   pthread_t p;
   Pthread_create(&p, NULL, child, NULL);
   Pthread_mutex_lock(&m);       // XXX wait for child.
   while (done == 0)             // XXX wait for child.
      pthread_cond_wait(&c, &m); // XXX wait for child.
   Pthread_mutex_unlock(&m);     // XXX wait for child.
   printf("parent: end\n");
   return 0;
}
